--[[
************************************************************************
Project				: Broker_TradeCooldowns
Author				: zhinjio
Project Revision	: r6
Project Date		: 20081029193518

File				: Broker_TradeCooldowns.lua
Commit Author		: zhinjio
Commit Revision		: 6
Commit Date			: 20081029193518
************************************************************************
Description	:
	Main addon file. 

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

--------------------------------------------------------------------------------------------------
-- Global SKG variables
--------------------------------------------------------------------------------------------------
BTC_VERSION = 1.0
-- SKG_DEBUG = true
BTC_DEBUG = false

local BTC = LibStub( "AceAddon-3.0" ):NewAddon( "BTC", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "BTC" )
_G["BTC"] = BTC

function BTC_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_TradeCooldowns\\icon:" .. fh .. "\124t"
	if not ( msg == nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " BTC: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function BTC_Debug( msg )
	if not ( msg == nil ) then
		if ( BTC_DEBUG ) then
			BTC_Print( "DEBUG: " .. msg )
		end
	end
end

local SharedCooldowns = {
	["Metals"] = { 11479, 11480, 60350 },
	["Elements"] = {
		17559, 17566, 17561, 25146, 17560, 17565, 17563, 17562, 17564, 28566,
		28585, 28567, 28568, 28583, 28584, 28582, 28580, 28569, 28581, 53777, 
		52776, 53781, 53782, 53775, 53774, 53773, 53771, 54020, 53779, 52780, 
		53783, 53784
	},
	["Diamonds"] = { 32765, 32766, 57425, 57427 },
}

local CooldownSpellList = {
-- Initialize my cooldowns list
	-- Alchemy
		-- Metals (shared cooldown)
			[11479] = "Metals",			-- Transmute: Iron to Gold
			[11480] = "Metals",			-- Transmute: Mithril to Truesilver
			[60350] = "Metals",			-- Transmute: Titanium
		-- Elements (shared cooldown)
			[17559] = "Elements",			-- Transmute: Air to Fire
			[17566] = "Elements",			-- Transmute: Earth to Life
			[17561] = "Elements",			-- Transmute: Earth to Water
			[25146] = "Elements",			-- Transmute: Elemental Fire            
			[17560] = "Elements",			-- Transmute: Fire to Earth
			[17565] = "Elements",			-- Transmute: Life to Earth           
			[17563] = "Elements",			-- Transmute: Undeath to Water
			[17562] = "Elements",			-- Transmute: Water to Air            
			[17564] = "Elements",			-- Transmute: Water to Undeath
			[28566] = "Elements",			-- Transmute: Primal Air to Fire
			[28585] = "Elements",			-- Transmute: Primal Earth to Life
			[28567] = "Elements",			-- Transmute: Primal Earth to Water
			[28568] = "Elements",			-- Transmute: Primal Fire to Earth
			[28583] = "Elements",			-- Transmute: Primal Fire to Mana
			[28584] = "Elements",			-- Transmute: Primal Life to Earth
			[28582] = "Elements",			-- Transmute: Primal Mana to Fire
			[28580] = "Elements",			-- Transmute: Primal Shadow to Water
			[28569] = "Elements",			-- Transmute: Primal Water to Air
			[28581] = "Elements",			-- Transmute: Primal Water to Shadow
			[53777] = "Elements",			-- Transmute: Eternal Air to Earth
			[52776] = "Elements",			-- Transmute: Eternal Air to Water
			[53781] = "Elements",			-- Transmute: Eternal Earth to Air
			[53782] = "Elements",			-- Transmute: Eternal Earth to Shadow
			[53775] = "Elements",			-- Transmute: Eternal Fire to Life
			[53774] = "Elements",			-- Transmute: Eternal Fire to Water
			[53773] = "Elements",			-- Transmute: Eternal Life to Fire
			[53771] = "Elements",			-- Transmute: Eternal Life to Shadow
			[54020] = "Elements",			-- Transmute: Eternal Might           
			[53779] = "Elements",			-- Transmute: Eternal Shadow to Earth
			[52780] = "Elements",			-- Transmute: Eternal Shadow to Life
			[53783] = "Elements",			-- Transmute: Eternal Water to Air
			[53784] = "Elements",			-- Transmute: Eternal Water to Fire
		-- Diamonds (shared cooldown)
			[32765] = "Diamonds",			-- Transmute: Earthstorm Diamond
			[32766] = "Diamonds",			-- Transmute: Skyfire Diamond
			[57425] = "Diamonds",			-- Transmute: Skyflare Diamond
			[57427] = "Diamonds",			-- Transmute: Earthsiege Diamond
    --Enchanting
		[28027] = true,			-- Prismatic Sphere
		[28028] = true,			-- Void Sphere
    
    -- Jewelcrafting
		[47280] = true,			-- Brilliant Glass    
    
    -- Tailoring        
		[26751] = true,			-- Primal Mooncloth
		[31373] = true,			-- Spellcloth
		[36686] = true,			-- Shadowcloth		
    
    -- Inscription
		[61288] = true,			-- Minor Inscription Research
		[61177] = true,			-- Northrend Inscription Research
}

function BTC_prettyTime( seconds )
	local retString = ""
	local left = seconds
	if ( left > 86400 ) then
		local days = floor( left / 86400 )
		left = left % 86400
		retString = retString .. days .. "d"
	end
	if ( left > 3600 ) then
		local hours = floor( left / 3600 )
		left = left % 3600
		retString = retString .. hours .. "h"
	end
	if ( left > 60 ) then
		local mins = floor( left / 60 )
		retString = retString .. mins .. "m"
	end
	return retString
end

function BTC:TRADE_SKILL_SHOW( eventName, arg1, ... )
	BTC_Debug( "In " .. eventName )

	local db = self.db.factionrealm[BTC.me]

	-- check the skill to see if its in our table already
	local tradeskill, mylevel, maxlevel = GetTradeSkillLine()

	if not ( db.skills[tradeskill] ) then
		db.skills[tradeskill] = {}
		db.skills[tradeskill].currlevel = mylevel
		db.skills[tradeskill].maxlevel = maxlevel
	end

	-- Thanks to Ackis (ARL) for scancode.
	for i = GetNumTradeSkills(), 1, -1 do
		local _, tradeType = GetTradeSkillInfo(i)
		if tradeType == "header" then
			ExpandTradeSkillSubClass(i)
		end
	end
	for i = 1, GetNumTradeSkills() do
		local tradeName, tradeType = GetTradeSkillInfo(i)
		-- Ignore all trade skill headers
		if (tradeType ~= "header") then
			-- Get the trade skill link for the specified recipe
			local SpellLink = GetTradeSkillRecipeLink(i)
			-- Get the SpellID from the spell link
			local SpellID = tonumber( string.match( SpellLink, "enchant:(%d+)" ) )

			-- Is this a spell I track the cooldown of?
			if ( CooldownSpellList[SpellID] ~= nil ) then
				-- Check if there is a current cooldown
				local cooldown = GetTradeSkillCooldown(i)
				if ( cooldown == nil ) then
					BTC_Debug( tradeName .. ", cd is nil" )
					db.cooldowns[SpellID] = {}
					db.cooldowns[SpellID].endtime = 0
					if ( CooldownSpellList[SpellID] ~= true ) then
						db.cooldowns[SpellID].displayName = CooldownSpellList[SpellID]
					else
						db.cooldowns[SpellID].displayName = tradeName
					end
				else
					BTC_Debug( tradeName .. ", cd is " .. cooldown )
					local cd = floor( cooldown )
					currtime = time()
					db.cooldowns[SpellID] = {}
					db.cooldowns[SpellID].endtime = currtime + cd
					if ( CooldownSpellList[SpellID] ~= true ) then
						db.cooldowns[SpellID].displayName = CooldownSpellList[SpellID]
					else
						db.cooldowns[SpellID].displayName = tradeName
					end
				end
			end
		end
	end
end

local LDB = LibStub( "LibDataBroker-1.1", true )
local launcher = LDB:NewDataObject( "BTC", {
	type = "data source",
	text = "BTC",
	label = "Broker_TradeCooldowns",
	icon = "Interface\\Addons\\Broker_TradeCooldowns\\icon",
	--[[
	OnClick = function(clickedframe, button)
		if ( button == "RightButton" ) then
			SKG_ShowConfig( clickedframe )
		else
			SKG_Toggle()
		end
	end, ]]--
	OnTooltipShow = function( tooltip )
		local db = BTC.db.factionrealm
		tooltip = tooltip or GameTooltip
		tooltip:AddLine( L["Professions :"], 1, 1, 1 )
		tooltip:AddLine( " " )
		-- Show my skills
		if ( db[BTC.me] ) then
			tooltip:AddLine( L["My Skills :"] )
			for k, v in pairs( db[BTC.me].skills ) do
			   tooltip:AddLine( "   " .. k .. " (" .. v.currlevel .. "/" .. v.maxlevel .. ")" ) 
			end
		end
		tooltip:AddLine( " " )
		-- cooldowns
		local Displayed = {}
		tooltip:AddLine( L["Cooldowns :"] )
		for k, v in pairs( db ) do
			if ( next( v.cooldowns ) ~= nil ) then
				tooltip:AddLine( "   " .. k )
			end
			for i, a in pairs( v.cooldowns ) do
				if not ( Displayed[a.displayName] ) then
					Displayed[a.displayName] = true
					local now = time()
					local timeleft = a.starttime
					if ( ( a.endtime == 0 ) or ( now > a.endtime ) ) then
						tooltip:AddLine( "      " .. a.displayName .. " : |cff00ff00Ready|r" )
					else
						local pretty = BTC_prettyTime( a.endtime - now )
						tooltip:AddLine( "      " .. a.displayName .. " : |cffff0000" .. pretty .. "|r" )
					end
				end
			end
		end
	end,		
} )

-- on init
function BTC:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub( "AceDB-3.0" ):New( "BTC_DB", nil, "Default" )
	if ( not self.db.factionrealm) then
		self.db.factionrealm = {}
	end

	BTC.me = UnitName( "player" )

	-- do we have any data yet for this toon? If not, init its table
	if not ( self.db.factionrealm[BTC.me] ) then
		self.db.factionrealm[BTC.me] = {
			skills = {},
			cooldowns = {},
		}
	end

	BTC_Debug( "In OnInit" )
	-- Event listeners
	BTC:RegisterEvent( "TRADE_SKILL_SHOW" )
end

--[[
************************************************************************
CHANGELOG:

Date : 10/29/08
	Initial version
************************************************************************
]]--